#include <gtk/gtk.h>
#include "application.h"

G_DEFINE_TYPE_WITH_PRIVATE (Application, application, GTK_TYPE_APPLICATION);

static void
application_startup (GApplication *application)
{
	Application *app = APPLICATION (application);

	G_APPLICATION_CLASS (application_parent_class)->startup (application);

	gtk_window_set_default_icon_name ("application");
	g_set_application_name (_("Boilerplate for C & GTK3"));

	g_action_map_add_action_entries (G_ACTION_MAP (application),
					 app_entries, G_N_ELEMENTS (app_entries),
					 application);

	application_init_accelerators (GTK_APPLICATION (app));
}

static void
application_activate (GApplication *application) {
	ApplicationPrivate *priv;
	Window *window;

	priv = application_get_instance_private (APPLICATION (application));

	window = window_new (APPLICATION (application));
	gtk_window_present_with_time (GTK_WINDOW (window), GDK_CURRENT_TIME);
}

static void
application_dispose (GObject *object) {
	ApplicationPrivate *priv;

	priv = application_get_instance_private (APPLICATION (object));

	G_OBJECT_CLASS (application_parent_class)->dispose (object);
}

static void
application_class_init (ApplicationClass *application_class) {
	GObjectClass *object_class = G_OBJECT_CLASS (application_class);
	GApplicationClass *application_class = G_APPLICATION_CLASS (application_class);

	object_class->dispose = application_dispose;

	application_class->startup = application_startup;
	application_class->activate = application_activate;
}

static void
application_init (Application *application) {
	ApplicationPrivate *priv;

	priv = application_get_instance_private (application);
}

Application *
application_new (void) {
    return g_object_new (APPLICATION_TYPE,
                         "application-id", "org.gtk.exampleapp",
                         "flags", G_APPLICATION_HANDLES_OPEN,
                         NULL);
}
